import pytest
from evrouting.charge.T import SoCProfile, SoCFunction, ChargingFunction, Label
from itertools import count


@pytest.fixture
def soc_profile():
    cost = 1
    capacity = 4

    return cost, capacity, SoCProfile(cost, capacity)


@pytest.fixture
def soc_profile_2():
    cost = 2
    capacity = 4

    return cost, capacity, SoCProfile(cost, capacity)


@pytest.fixture
def ch_function():
    c = 2
    capacity = 4

    return c, capacity, ChargingFunction(c, capacity)


@pytest.fixture
def ch_function_fast():
    c = 3
    capacity = 4

    return c, capacity, ChargingFunction(c, capacity)


last_cs_generator = count()


@pytest.fixture
def label(soc_profile_2):
    _, _, profile = soc_profile_2
    return Label(
        t_trip=10,
        soc_last_cs=2,
        soc_profile_cs_v=profile,
        last_cs=next(last_cs_generator)
    )


@pytest.fixture
def soc_function(label, ch_function):
    _, _, cf = ch_function
    return SoCFunction(label, cf)


@pytest.fixture
def soc_function_fast(label, ch_function_fast):
    _, _, cf = ch_function_fast
    return SoCFunction(label, cf)
